/*
	$Id: GlobalVariables.java 261 2006-08-14 19:05:51Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import org.w3c.dom.NodeList;
import org.w3c.dom.Element;
import java.io.PrintWriter;
import java.util.LinkedList;

/**
   ХѿΥåȤǤ
*/
public class GlobalVariables {

    /** ХѿΥꥹ */
    private LinkedList<GlobalVariable> v;

    /**
       ХѿΥåȤޤ

       @param gm 롼ץޥ͡
       @param nodes ХѿΥΡɥꥹ
    */
    public GlobalVariables(final GroupManager gm, final NodeList nodes) {
	v = new LinkedList<GlobalVariable>();

	for (int k = 0, n = nodes.getLength(); k < n; ++k) {
	    Element elem = (Element) nodes.item(k);
	    GlobalVariable m = gm.createGlobalVariable(elem);
	    v.add(m);
	}
    }

    /**
       ɤϤޤ

       @param wr 饤
    */
    public void printCode(final PrintWriter wr) {
	if (v.size() == 0) {
	    return;
	}
	wr.println("");
	for (GlobalVariable m : v) {
	    m.printCode(wr);
	}
    }

    /**
       ֤ΥإåϤޤ

       @param wr 饤
    */
    public void printStubHeader(final PrintWriter wr) {
	if (v.size() == 0) {
	    return;
	}
	wr.println("");
	for (GlobalVariable m : v) {
	    m.printStubHeader(wr);
	}
    }

    /**
       ֤ΥɤϤޤ

       @param wr 饤
    */
    public void printStubCode(final PrintWriter wr) {
	if (v.size() == 0) {
	    return;
	}
	wr.println("");
	for (GlobalVariable m : v) {
	    m.printStubCode(wr);
	}
    }

    /**
       ΥإåHTMLǽϤޤ

       @param wr 饤
    */
    private void printSummaryHeader(final PrintWriter wr) {
	wr.println("<h2>Global Variable Summary</h2>");
    }

    /**
       ܺ٤ΥإåHTMLǽϤޤ

       @param wr 饤
    */
    private void printDetailHeader(final PrintWriter wr) {
	wr.println("<h2>Global Variable Detail</h2>");
    }

    /**
       ܺ٤ΥإåTeXǽϤޤ

       @param wr 饤
    */
    private void printTexDetailHeader(final PrintWriter wr) {
	wr.println("\\SglobalVariable");
    }

    /**
       HTMLǽϤޤ

       @param wr 饤
    */
    public void printSummary(final PrintWriter wr) {
	if (v.size() == 0) {
	    return;
	}
	printSummaryHeader(wr);
	wr.println(""
+ "    <table width=\"100%\" cellspacing=\"0\" border=\"1\">");
	for (GlobalVariable m : v) {
	    m.printSummary(wr);
	}
	wr.println(""
+ "    </table>");
    }

    /**
       ܺ٤HTMLǽϤޤ

       @param wr 饤
    */
    public void printDetail(final PrintWriter wr) {
	if (v.size() == 0) {
	    return;
	}
	printDetailHeader(wr);
	for (GlobalVariable m : v) {
	    m.printDetail(wr);
	    wr.println("<hr>");
	}
    }

    /**
       ܺ٤TeXǽϤޤ

       @param wr 饤
    */
    public void printTexDetail(final PrintWriter wr) {
	if (v.size() == 0) {
	    return;
	}
	printTexDetailHeader(wr);
	for (GlobalVariable m : v) {
	    m.printTexDetail(wr);
	}
    }

}
