/*
	$Id: StructUnionMember.java 263 2006-08-16 18:50:56Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
   ¤ΤΥФޤ϶ΤΥФΤstructޤunionΥ
   ФǤ

   Υ饹ɽФStructUnionФȸƤӤޤΥФο
   Ϲ¤Τޤ϶ΤǤ

   structmemberǡunionmemberǤбޤ
*/
public class StructUnionMember extends CompoundMember {

    /**
       StructUnionФޤ

       @param gm 롼ץޥ͡
       @param parentName Ƥ̾
       @param label "struct" ޤ "union"
       @param tag ̾
       @param elem structmemberǤޤunionmember
    */
    public StructUnionMember(final GroupManager gm, final String parentName,
			     final String label, final String tag,
			     final Element elem) {
	super(parentName, (tag.equals("") ? label : label + " " + tag), elem);

	String implName = tag;
	if (implName.equals("")) {
	    implName = "@" + IDManager.getInstance().getUniqueID();
	    setDescType(label + " " + implName);
	}
	setCompoundImpl(new CompoundImpl(gm, label, elem, implName,
					 getDescType()) {
	    protected String getTagName() {
		return StructUnion.TAG_NAME;
	    }
	    protected Description getDescription(final ChildrenFilter c) {
		return CompoundMember.getDescription(c);
	    }
	    protected Components getComponents(final GroupManager gm,
					       final String descType,
					       final NodeList nodes) {
		return new Members(gm, descType, nodes);
	    }
	});
    }
}
